DeferredFileOutputStream (Commons IO 2.5)
Date: 2016-12-01

org.apache.commons.io.output

## Class DeferredFileOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.apache.commons.io.output.ThresholdingOutputStream
    - - org.apache.commons.io.output.DeferredFileOutputStream

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable

      public class DeferredFileOutputStream
      extends ThresholdingOutputStream

  An output stream which will retain data in memory until a specified threshold is reached, and only then commit it to disk. If the stream is closed before the threshold is reached, the data will not be written to disk at all.

  This class originated in FileUpload processing. In this use case, you do not know in advance the size of the file being uploaded. If the file is small you want to store it in memory (for speed), but if the file is large you want to store it to file (to avoid memory issues).

  Version:
    $Id: DeferredFileOutputStream.java 1686747 2015-06-21 18:44:49Z krosenvold $

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private boolean` | `closed` True when close() has been called successfully.
    `private java.io.OutputStream` | `currentOutputStream` The output stream to which data will be written at any given time.
    `private java.io.File` | `directory` The directory to use for temporary files.
    `private ByteArrayOutputStream` | `memoryOutputStream` The output stream to which data will be written prior to the theshold being reached.
    `private java.io.File` | `outputFile` The file to which output will be directed if the threshold is exceeded.
    `private java.lang.String` | `prefix` The temporary file prefix.
    `private java.lang.String` | `suffix` The temporary file suffix.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `DeferredFileOutputStream(int threshold, java.io.File outputFile)` Constructs an instance of this class which will trigger an event at the specified threshold, and save data to a file beyond that point.
    `private` | `DeferredFileOutputStream(int threshold, java.io.File outputFile, java.lang.String prefix, java.lang.String suffix, java.io.File directory)` Constructs an instance of this class which will trigger an event at the specified threshold, and save data either to a file beyond that point.
    `` | `DeferredFileOutputStream(int threshold, java.lang.String prefix, java.lang.String suffix, java.io.File directory)` Constructs an instance of this class which will trigger an event at the specified threshold, and save data to a temporary file beyond that point.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes underlying output stream, and mark this as closed
    `byte[]` | `getData()` Returns the data for this output stream as an array of bytes, assuming that the data has been retained in memory.
    `java.io.File` | `getFile()` Returns either the output file specified in the constructor or the temporary file created or null.
    `protected java.io.OutputStream` | `getStream()` Returns the current output stream.
    `boolean` | `isInMemory()` Determines whether or not the data for this output stream has been retained in memory.
    `protected void` | `thresholdReached()` Switches the underlying output stream from a memory based stream to one that is backed by disk.
    `void` | `writeTo(java.io.OutputStream out)` Writes the data from this output stream to the specified output stream, after it has been closed.

    - ### Methods inherited from class org.apache.commons.io.output.ThresholdingOutputStream

      `checkThreshold, flush, getByteCount, getThreshold, isThresholdExceeded, resetByteCount, setByteCount, write, write, write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### memoryOutputStream

          private ByteArrayOutputStream memoryOutputStream

      The output stream to which data will be written prior to the theshold being reached.

    - #### currentOutputStream

          private java.io.OutputStream currentOutputStream

      The output stream to which data will be written at any given time. This will always be one of `memoryOutputStream` or `diskOutputStream`.

    - #### outputFile

          private java.io.File outputFile

      The file to which output will be directed if the threshold is exceeded.

    - #### prefix

          private final java.lang.String prefix

      The temporary file prefix.

    - #### suffix

          private final java.lang.String suffix

      The temporary file suffix.

    - #### directory

          private final java.io.File directory

      The directory to use for temporary files.

    - #### closed

          private boolean closed

      True when close() has been called successfully.

  - ### Constructor Detail

    - #### DeferredFileOutputStream

          public DeferredFileOutputStream(int threshold,
                                  java.io.File outputFile)

      Constructs an instance of this class which will trigger an event at the specified threshold, and save data to a file beyond that point.
      Parameters:
        `threshold` - The number of bytes at which to trigger an event.
        `outputFile` - The file to which data is saved beyond the threshold.

    - #### DeferredFileOutputStream

          public DeferredFileOutputStream(int threshold,
                                  java.lang.String prefix,
                                  java.lang.String suffix,
                                  java.io.File directory)

      Constructs an instance of this class which will trigger an event at the specified threshold, and save data to a temporary file beyond that point.
      Parameters:
        `threshold` - The number of bytes at which to trigger an event.
        `prefix` - Prefix to use for the temporary file.
        `suffix` - Suffix to use for the temporary file.
        `directory` - Temporary file directory.
      Since:
        1.4

    - #### DeferredFileOutputStream

          private DeferredFileOutputStream(int threshold,
                                  java.io.File outputFile,
                                  java.lang.String prefix,
                                  java.lang.String suffix,
                                  java.io.File directory)

      Constructs an instance of this class which will trigger an event at the specified threshold, and save data either to a file beyond that point.
      Parameters:
        `threshold` - The number of bytes at which to trigger an event.
        `outputFile` - The file to which data is saved beyond the threshold.
        `prefix` - Prefix to use for the temporary file.
        `suffix` - Suffix to use for the temporary file.
        `directory` - Temporary file directory.

  - ### Method Detail

    - #### getStream

          protected java.io.OutputStream getStream()
                                            throws java.io.IOException

      Returns the current output stream. This may be memory based or disk based, depending on the current state with respect to the threshold.
      Specified by:
        `getStream` in class `ThresholdingOutputStream`
      Returns:
        The underlying output stream.
      Throws:
        `java.io.IOException` - if an error occurs.

    - #### thresholdReached

          protected void thresholdReached()
                                   throws java.io.IOException

      Switches the underlying output stream from a memory based stream to one that is backed by disk. This is the point at which we realise that too much data is being written to keep in memory, so we elect to switch to disk-based storage.
      Specified by:
        `thresholdReached` in class `ThresholdingOutputStream`
      Throws:
        `java.io.IOException` - if an error occurs.

    - #### isInMemory

          public boolean isInMemory()

      Determines whether or not the data for this output stream has been retained in memory.
      Returns:
        `true` if the data is available in memory; `false` otherwise.

    - #### getData

          public byte[] getData()

      Returns the data for this output stream as an array of bytes, assuming that the data has been retained in memory. If the data was written to disk, this method returns `null`.
      Returns:
        The data for this output stream, or `null` if no such data is available.

    - #### getFile

          public java.io.File getFile()

      Returns either the output file specified in the constructor or the temporary file created or null.

      If the constructor specifying the file is used then it returns that same output file, even when threshold has not been reached.

      If constructor specifying a temporary file prefix/suffix is used then the temporary file created once the threshold is reached is returned If the threshold was not reached then `null` is returned.

      Returns:
        The file for this output stream, or `null` if no such file exists.

    - #### close

          public void close()
                     throws java.io.IOException

      Closes underlying output stream, and mark this as closed
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `ThresholdingOutputStream`
      Throws:
        `java.io.IOException` - if an error occurs.

    - #### writeTo

          public void writeTo(java.io.OutputStream out)
                       throws java.io.IOException

      Writes the data from this output stream to the specified output stream, after it has been closed.
      Parameters:
        `out` - output stream to write to.
      Throws:
        `java.io.IOException` - if this stream is not yet closed or an error occurs.

Copyright (c) 2002-2016 Apache Software Foundation